/**********************************************
* PIC24FJ32GA002 t@~ 
*  NTSCrfIó@AP1@@@NTSC8.
**********************************************/
#include "p24FJ32GA002.h"
#include "NTSC.h"
#include <math.h>
#include <stdlib.h>

/// RtBM[V rbg̐ݒ@ONbN 32MHztXs[h
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2( IESO_OFF & FNOSC_PRIPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_HS)
	 
//// I/Os`
#define SW1		!PORTBbits.RB7
//// 萔`
#define X0	10
#define Y0	10
#define Y2	(V_RES/2)
#define PI	3.141592654f
#define NODES	20
#define SIDE	10
#define AT(x, y)	{cx = (x); cy = (y);}
/// ϐ`
unsigned char SWState,SWOld;	// XCb`؂ւXe[g
int x;							// Ot\pW
unsigned int POT0, POT1;		// POTݒl
unsigned char CompFlag;			// ADtO
unsigned char TrigFlag;
unsigned int Data[512];			// IVpf[^obt@
//// Œ胁bZ[W(PSV)
const unsigned char Mesg[] = "Test NTSC Graphic Character";
const unsigned char Header[] = "Oscilloscope";
const unsigned char Time1[] = "V:1.0V/Div  H:250usec/Div";
const unsigned char Time2[] = "V:1.0V/Div  H:1msec/Div";
const unsigned char Time3[] = "V:1.0V/Div  H:10msec/Div";

/************************************************
* C֐
*   HEXXCb`̐ݒŏeύX
*   ꏄƂHEXXCb`̓eǂݍŕ
************************************************/
int main(void){
	int i;

	CLKDIV = 0;							// NbN̕1:1ɐݒ
    AD1PCFG = 0xFFCC;   				// AN0,1,4,5ȊOfBW^Ɏw
	/// |[g̓o̓[hݒ
	TRISA = 0x33;						// AD Input
	LATB = 0xFFFF;						// LED ALL Off
	TRISB = 0xF38F;						// |[gB
	/// XCb`pvAbv̗L
	CNPU1 = 0x7800;						// CN11-14 HEXSW
	CNPU2 = 0x00E0;						// SW1-3(CN21,22,23)|[g̃vAbv
	/// stݒ
	RPOR2bits.RP4R = 7;					// SDO1 out to RP5(Video)
	/// 
	VideoInit();						// NTSCrfI䏉
	SRbits.IPL = 2;						// CPŮ荞݃xݒ
	x = 0;
	SWOld = 0;
	CompFlag = 0;
	/////////// C[v ////////////////
	while(1){
		/// HEXXCb`Ńp^[ύX
		SWState = (~(PORTB >> 12)) & 0x000F;
		switch(SWState)					// XCb`Ԃŕ
		{
			case 0:  /// Œp^[\̌JԂ
				AllSet(0xFFFF);			// x^p^[\
				Delay_ms(1000);
				AllSet(0xAAAA);			// ŏ
				Delay_ms(1000);
				AllSet(0x5555);			// ŏ
				Delay_ms(1000);
				AllSet(0);				// ʕ\
				Delay_ms(1000);
				break;
			default:					// ftHg̏ꍇ
			case 1:	///// 璹iqeXgp^[\
				if(SWState != SWOld)
					TestPatn();
				break;
			case 2:	//// Ug`\
				POT1 = POT1+100;
				if(POT1 > 1023)
					POT1 = 0;
				wave();					// Ug`\
				Delay_ms(1000);
				break;
			case 3:	//// _\
				POT1 = POT1+100;
				if(POT1 > 1023)
					POT1 = 0;
				srand(POT1/8);			// POTŒ̕ύX
				AllSet(0);				// Clear
				/// _`(100{`)
				for(i=0; i<100; i++)
					line(rand()%H_RES, rand()%V_RES, rand()%H_RES, rand()%V_RES);
				Delay_ms(1000);	
				break;
			case 4:	//// 2Ot\ ԊuōύX
				POT1 = POT1+100;
				if(POT1 > 1023)
					POT1 = 0;
				D2Graph();				// QcOt\
				Delay_ms(1000);
				break;
			case 5:	//// `rbhh\ 1bƂ4s\JԂ
				DispChar();
				Delay_ms(1000);
				break;
			case 6:	//// IVXR[v[hJn
			case 7: ////
			case 8: //// IVXR[v@VO[hJn
				POT_In();
				ADInit();				// A/DRo[^ݒ
				x = 0;					// XW
				TrigFlag = 0;
				CompFlag = 0;			// ADtONA
				T3CONbits.TON = 1;		// ADRo[^X^[g
				while(!CompFlag);
				Oscillo();				// IVXR[v\
				CompFlag = 0;
				break;
		}
		SWOld = SWState;
	}				
}

/******************************************
*  SʌŒf[^Zbg
*@@ 16rbg̃p^[őŜݒ肷
******************************************/
void AllSet(int patn){
	int i;

	MPtr = VMem;				// VRAM|C^Zbg	
	for(i=0; i<3072; i++)
		*MPtr++ = patn;			// Œp^[ݒ
}

/******************************************
*  璹iqeXgp^[\
*@@@Œp^[̂
******************************************/
void TestPatn(void){
	int i, j;

	MPtr = VMem;				// VRAM|C^Zbg	
	for(j=0; j<4; j++) {		// 5JԂ
		for(i=0; i<96; i++){	// 24Line
			*MPtr++ = 0xFFFF;	// 1/16s
			*MPtr++ = 0xFFFF;	// 1/16s
			*MPtr++ = 0;		// 1/16s
			*MPtr++ = 0;		// 1/16s
		}
		for(i=0; i<96; i++){	// 24Line
			*MPtr++ = 0;
			*MPtr++ = 0;
			*MPtr++ = 0xFFFF;
			*MPtr++ = 0xFFFF;
		}
	}
}
/******************************************
* Ug`\֐
*@@UPOTŉς
*******************************************/
void wave(void) {
	float xf, yf;

	AllSet(0);						// Clear
	/// Ug`\
	line(X0, 0, X0, V_RES);			// Y axis
	line(X0-5, Y2, H_RES, Y2);		// X axis
	for(x=0; x<256; x++)
	{
		xf = (8 * PI / 256) *(float)x;
		yf = (float)(POT1/8) / (8 * PI) *xf *sin(xf);
		Plot(x+X0, yf+Y2);
	}
}
/******************************************
* msecPʃfBC֐
*@@1msec
*******************************************/
void Delay_ms(long msec){
	long i;

 	for(i=0; i< msec*680; i++)
		Nop();Nop();
}
/*********************************************
*  2̃Ot`֐
*   z(x,y) = 1/(1+SQRT(x2+y2))*COS(SQRT(x2+y2))
*    (-3*PI< x,y < 3*PI͈̔)
*   z̍őlPOTŕύX
**********************************************/
void D2Graph(void) {
	int i, j, px, py, y, z;
	float zf, xf, yf, sf;
	struct{
		int x;
		int y;
	} edge[NODES], prev;

	AllSet(0);							// Clear
	line(X0, 10, X0, V_RES);			// z axis
	line(X0-5, Y0, H_RES-10, Y0);		// x axis
	line(X0-2, Y0-2, X0+120, Y0+120);	// y axis
	for(j=0; j<NODES; j++) {
		edge[j].x = X0 + j*SIDE/2;
		edge[j].y = Y0 + j*SIDE/2;
	}
	for(i=0; i<NODES; i++) {
		x = i *SIDE;
		xf = (6 * PI / 200) *(float)(x-100);
		prev.y = Y0;
		prev.x = X0 + x;
		for(j=0; j<NODES; j++) {
			y = j * SIDE;
			yf = (6 * PI /200) * (float)(y -100);
			sf = sqrt(xf * xf + yf * yf);
			zf = 1/(1+sf) * cos(sf);
			z = zf * (POT1/6);
			px = X0 + x + y/2;
			py = Y0 + z + y/2;
			Plot(px, py);
			line(px, py, prev.x, prev.y);
			line(px, py, edge[j].x, edge[j].y);
			prev.x = px;
			prev.y = py;
			edge[j].x = px;
			edge[j].y = py;
		}
	}
}
/******************************************
*	ASCII\
*@@@964sŕ\@5sƂɂ炷
*******************************************/
void DispChar(void){
	int i;

	AT(0, 0);					// bZ[W\
	putsV(Mesg);
	//// `rbhh\@96
	x++;						// ̍s
	AT(0, 4*x);
	for(i=32; i<128; i++)
		putcV(i);
	if(x > 6){
		x = 0;
		AllSet(0);				// Clear
	}
}
/*****************************************
*IVXR[vpADRo[^ݒ
*^C}R̒ԊuAN0̂ݎvA16Ŋ
*****************************************/
void ADInit(void){
	// Timer3̐ݒ NbNA1/1AFOSC=16MHz

	switch(SWState){
		case 6:
		case 8:
			PR3 = 0x50-1;		// 5usecC^[o
			break;
		case 7:
			PR3 = 0x140-1;		// 20usec
			break;
		default:
			PR3 = 0xC80-1;		// 200usec
			break;
	}
	T3CON = 0x0000;
	// ADC̐ݒύX
	AD1CON1 = 0x0044;			// AD OnAA^C}3gKATv
	AD1CON2 = 0x043C;			// AVdd, AVss,XLA16ڊ荞
	AD1CON3 = 0x0202;			// 2TadTvAad = 2*Tcy
	AD1CHS  = 0x0000;			// `lI(XL)
	AD1PCFG = 0xFFCC;			// RA0,1,4,5AiO 
	AD1CSSL = 0x0001;			// AN0XL
	IPC3bits.AD1IP = 3;
	IEC0bits.AD1IE = 1;			// 荞݋
	AD1CON1bits.ADON = 1;
}
/*******************************************
*  IVXR[vpf[^擾
*  ADϊʂ16̃f[^֕ۑ̂
*  512̃f[^ۑłIA^C}3~
********************************************/
void __attribute__((interrupt, auto_psv)) _ADC1Interrupt(void)
{
	PORTBbits.RB6 = 1;			// debug
	IFS0bits.AD1IF = 0;			// 荞݃tONA
	Data[x++] = ADC1BUF0;
	Data[x++] = ADC1BUF1;
	Data[x++] = ADC1BUF2;
	Data[x++] = ADC1BUF3;
	Data[x++] = ADC1BUF4;
	Data[x++] = ADC1BUF5;	
	Data[x++] = ADC1BUF6;
	Data[x++] = ADC1BUF7;
	Data[x++] = ADC1BUF8;
	Data[x++] = ADC1BUF9;	
	Data[x++] = ADC1BUFA;
	Data[x++] = ADC1BUFB;
	Data[x++] = ADC1BUFC;
	Data[x++] = ADC1BUFD;	
	Data[x++] = ADC1BUFE;
	Data[x++] = ADC1BUFF;
	if(x > 511){
		CompFlag = 1;
		T3CONbits.TON = 0;
	}
	PORTBbits.RB6 = 0;			// debug
}
/************************************************
*  IVXR[v\Aۑf[^\
*  [h̏ꍇ̓gKoĂ̈ʒu256f[^\
*  @gKvȂ΍ŏ̈ʒu256f[^\
*  VO[h̏ꍇPOT̒lɉčW炵ĕ\
*************************************************/
void Oscillo(void){
	int i;

	AxisDraw();
	//// [h̏ꍇ
	if((SWState == 6)||(SWState == 7)){		// [h
		x = 1;								// ŏ̃f[^
		//// gK`FbN
		while((x < 256) && !((Data[x]<POT1) && (Data[x+1]>=POT1))){
			x++;
		}
		//// gKAg`\
		if(x<256){
			for(i=0; i<256; i++)
				line(i, Data[i+x-1]/6, i+1, Data[i+x]/6);
		}
		else {
			for(i=0; i<256; i++)
				line(i, Data[i]/6, i+1, Data[i+1]/6);
		}
		Delay_ms(500);
		x = 0;						// [ɖ߂		
		T3CONbits.TON = 1;			// ăX^[g
	}
	//// VO[h̏ꍇ
	else if(SWState == 8){			// VO[hH
		while(!SW1){
			POT_In();
			AxisDraw();
			//// W炵ĕ`
			for(x=1; x<256; x++){
				line(x-1, Data[POT1/4+x-1]/6, x, Data[POT1/4+x]/6);
			}
			Delay_ms(300);
		}
		// SW1ꂽČv
		ADInit();
		x = 0;						// [ɖ߂
		CompFlag = 0;
		T3CONbits.TON = 1;			// ČvX^[g
	}
}
/******************************************
*  Wn̕\
*
*******************************************/
void AxisDraw(void){
	int i;

	AllSet(0);						// Clear
	AT(1, 0);						// w
	putsV(Header);					// o\
	AT(6, 23)						// w
	switch(SWState){
		case 6:
		case 8:
			putsV(Time1);			// WAԕ\
			break;
		case 7:
			putsV(Time2);
			break;
		default:
			putsV(Time3);
			break;
	}
	line(0, 0, 0, (V_RES-1));		// Y axis
	for(i=1; i<6; i++)
		dotyline(i*50);
	line(0, Y2, H_RES-1, Y2);		// X axis
	dotxline(Y2-58);
	dotxline(Y2+58);
}
/******************************************
*  POŤݒl͊֐
*@@POT0POT1̒l蓮ϊ[hœ͂
******************************************/
void POT_In(void){
	// ADC̐ݒ
	IEC0bits.AD1IE = 0;			// 荞݋֎~	
	AD1CON1 = 0x00E0;			// AD OffAAϊJnA蓮gK
	AD1CON2 = 0x0000;			// AVdd, AVss,XLȂA񊄂荞
	AD1CON3 = 0x0303;			// 3TadTvAad = 2*Tcy
	AD1PCFG = 0xFFCC;			// RA0,1,4,5AiO 
	AD1CSSL = 0x0000;			// XLȂ
	AD1CHS  = 0x0004;			// `l4I
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;		// TvOJnAϊJn
	while(!IFS0bits.AD1IF);
	POT0 = ADC1BUF0;
	IFS0bits.AD1IF = 0;
	AD1CON1bits.ADON = 0;
	AD1CHS  = 0x0005;			// `l5I
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;		// TvOJnAϊJn
	while(!IFS0bits.AD1IF);
	POT1 = ADC1BUF0;
	IFS0bits.AD1IF = 0;
	AD1CON1bits.ADON = 0;		// ADC Stop
}

